<template>
    <!--<div class="container-fluid">-->
    <div>
        <div class="d-flex justify-content-center">
            <div class="wash_board_wrap">

                <!--Board Body-->
                <div class="wb_body">
                    <transition-group name="fade" mode="in-out">
                        <div v-for="(item, key) in items" :key="key">
                            <div class="justify-content-between wb_row" :class="item.status_class">
                                <div class="col_1">
                                    <div class="number_box">
                                        <div class="car_number" :class="item.number_type" v-html="item.number_html"></div>
                                    </div>
                                    <div class="where_key_box">
                                        <div class="key">{{ item.where_key }}</div>
                                    </div>
                                </div>
                                <div class="col_2 flex-column">
                                    <div class="c2_r1">
                                        <div class="time" ref="datatime" :data="item.start_times">{{ this.timer }}</div>
                                        <div class="destination">{{ item.destination }}</div>
                                    </div>
                                    <div class="c2_r2">
                                        <div class="status">{{ item.status_text }}</div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </transition-group>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'wash-board',
    data() {
        return {
            items: [],
            interval: null,
            interval2: null,
            times: null,
            diffTime: '',
            status_class: '',
            number_type: '',
            number_html: '',
            status_text: '',
            where_key: '',
            destination: '',
            startTime: '',
            timer: '--:--',
            start_times: '',
            end_times: ''
        }
    },
    created() {
    },
    mounted() {
        axios.get("/api/read")
            .then(response => {
                this.items = response.data
            })
        clearInterval(this.interval);
        clearInterval(this.interval2);
        this.interval = setInterval(this.refreshData, 5000)
        this.interval2 = setInterval(this.countDownTimer, 1000)
    },
    methods: {
        refreshData() {
            axios.get("/api/read")
                .then(response => {
                    this.items = response.data
                })
        },
        countDownTimer() {
            let difff = 0;
            for (let i = 0; i < this.$refs.datatime.length; i++) {
                this.startTime = this.$refs.datatime[i].attributes.data.value
                this.countDownDate = new Date(this.startTime).getTime()
                this.nowTime = new Date().getTime()
                let diff = this.countDownDate - this.nowTime
                if (diff > 0) {
                    difff = diff;
                } else {
                    difff = diff * -1;
                }
                let h = Math.floor((difff % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60))
                let m = Math.floor((difff % (1000 * 60 * 60)) / (1000 * 60))
                let s = Math.floor((difff % (1000 * 60)) / 1000)

                this.thrs = h > 9 ? h : '0' + h
                this.tmns = m > 9 ? m : '0' + m
                this.tsec = s > 9 ? s : '0' + s

                // масштаб таймера
                if(difff >= 3600000) {
                    this.$refs.datatime[i].innerText = this.thrs + ':' + this.tmns + ':' + this.tsec
                    this.$refs.datatime[i].className = 'time timer_hh_mm_ss'
                } else {
                    this.$refs.datatime[i].innerText = this.tmns + ':' + this.tsec
                }
            }
        }
    }
}
</script>

<style scoped>

</style>